--[[
Crazy King LUA v091012pm
by LILAX
Kata helped to script for SENSOR to check Players' whereabouts,
and Speads/TimeLeft in HUDS section.
]]

-------------- Initial Values ------------------
SAINT = nil
CollectionsUsed = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31}
PIN = nil -- whereabouts of the mark of the PLACE
FIRST = false
TIME = 0
TOPSCORE = 0
GETTIME = 0
XXX, YYY, ZZZ, POL = nil, nil, nil, nil
------------------------------------------------


-------------- Idling Programms list -----------
function Triggers.idle()

	VAREA()
	SENSOR()
	RANK()
	HUDS()

end


--------- SENSOR adds pts and indicades whereabouts of the AREA, also shows what to do. --------
function SENSOR()


	for P in Players() do
		P.compass.lua = true
		P.compass.beacon = true


		if P.dead then -- Player is dead
			P.overlays[4].text = "                    Revive and go for the AREA now!"
			P.overlays[4].color = 0

		elseif not P.dead then -- Player is alive
			if math.sqrt((PIN.x - P.x) ^ 2 + (PIN.y - P.y) ^ 2 + (PIN.z - P.z) ^ 2) <= 4 then -- alive and in the AREA.
				P.points = P.points + 1
				P.compass:all_on()
				P.overlays[4].text = "                    Now you are in the Area. Stay ALIVE!"
				P.overlays[4].color = math.floor(Game.global_random(8))
				P:play_sound("exiting lava", 5)


			else -- alive but not in the AREA.
				P.overlays[4].text = "                    Follow your sensor to go to the AREA!"
				P.overlays[4].color = 0
				P.compass.x, P.compass.y = PIN.x, PIN.y

			end

		end

	end


end


-------------- Checking game type --------------
function Triggers.init()



	if (Game.type == "netscript") then

		Game.scoring_mode = "most time"

		for P in Players() do
			P.points = 0
			P._GETTIME = 0
			P:play_sound("entering lava")
		end

		-------------- Random AREA Choosing --------------
		-- i thought i needed to make DBs of polygons, but it wasnt needed
		--		for G in Polygons() do
		--			table.insert(G)
		--		end
		-------- message from lilax ends -------------




	else -- invalid gametype

		Players.print("The rule NETSCRIPT must be chosen so you can play the rule.")
		for P in Players() do
			P:damage(500,teleporter)

		end
	end
end


------------ Random AREA Choosing and Visualizing -------------
function VAREA()

	-------- "FIRST" ensures this part works for the first time ----
	if FIRST == false then
		FIRST = true
		PIN = Scenery.new(0, 0, 0, 0, "sun")
	end

	-------- put something somewhere.(see right above) --------
	if TIME >= 900 then --counting for moving the scenary. 1800tik = 1min,  30tik = 1sec
		TIME = 0
		local r = math.floor(Game.global_random(# Polygons))
		XXX = Polygons[r].x
		YYY = Polygons[r].y
		ZZZ = Polygons[r].z
		POL = Polygons[r]
		PIN:position(XXX, YYY, ZZZ+1.000, POL)
		Players.print("The Area has been moved.")
		Polygons[r]:play_sound("juggernaut exploding")

		for P in Players() do
			P:fade_screen("big negative")
--			P:play_sound("rocket flyby")-- if sound is required when it moves, remove "--".

		end

	else
		TIME = TIME + 1

	end

end



---------- listing up by rank internally. thx Kata, here based on your script.
function RANK()
	for P in Players() do
		P._rank = 1
		for i = 0, #Players - 1 do
			if Game.type ~= "tag" then
				if Players[i].points > P.points then
					P._rank = P._rank + 1
				end
			else
				if Players[i].points < P.points then
					P._rank = P._rank + 1
				end
			end
		end
	end
end
------------------------------------------------


-------- Showing texts Rank, Score, etc,. -------------
function HUDS()

	for P in Players() do
		if (P._rank == 1) then -- TOPSCORE
			TOPSCORE = P.points
			P.overlays[0].color = 3 --DEEP GREEN
		elseif (P._rank == #Players) then -- worst rank
			P.overlays[0].color = 2 --RED
			SPREAD = P.points - TOPSCORE
		elseif (P._rank == #Players - 1) then
			P.overlays[0].color = 5 --YELLOW
		else
			P.overlays[0].color = 1
		end


		-------- [Showing Score and spread] -------------

		P.overlays[0].text = "Rank: "..P._rank.."\/"..#Players..""




		-------Score (time)----------
		local scmin, scsec, sctik, scmzro, scszro, sctzro = 0, 0, 0, "", "", ""
		scmin = math.floor(P.points / 1800)
		scsec = math.floor(P.points / 30) - scmin * 60
		sctik = math.floor(((P.points - scsec * 30 - scmin * 1800) / 30) * 99)

		if scmin < 10 then scmzro = "0" else scmzro = "" end --keep figure numbers of min 2.
		if scsec < 10 then scszro = "0" else scszro = "" end --sec
		if sctik < 10 then sctzro = "0" else sctzro = "" end --tik

		P.overlays[1].color = 4 -- Light Blue
		P.overlays[1].text = "Score: "..(scmzro)..scmin..":"..(scszro)..scsec..":"..(sctzro)..sctik..""




		-------SPREAD (time)----------
		local spmin, spsec, sptik, spmzro, spszro, sptzro, spread = 0, 0, 0, "", "", "", 0
		spread = math.floor(P.points - TOPSCORE)
		spmin = math.floor(spread / 1800)
		spsec = math.floor(spread / 30) - spmin * 60
		sptik = math.floor(((spread - spsec * 30 - spmin * 1800) / 30) * 99)

		if spmin < 10 then spmzro = "0" else spmzro = "" end--keep figure numbers of min 2.
		if spsec < 10 then spszro = "0" else spszro = "" end--sec
		if sptik < 10 then sptzro = "0" else sptzro = "" end--tik

		P.overlays[2].text = "    Spread: "..(spmzro)..spmin..":"..(spszro)..spsec..":"..(sptzro)..sptik..""





		-------TIME REMAININGS----------
		local min, sec, tik, mzro, szro, tzro = 0, 0, 0, "", "", ""
		min = math.floor(Game.time_remaining / 1800)
		sec = math.floor(Game.time_remaining / 30) - min * 60
		tik = math.floor(((Game.time_remaining - sec * 30 - min * 1800) / 30) * 99)

		if min < 10 then mzro = "0" else mzro = "" end--keep figure numbers of min
		if sec < 10 then szro = "0" else szro = "" end--sec
		if tik < 10 then tzro = "0" else tzro = "" end--tik
		P.overlays[3].text = "        TimeLeft: "..(mzro)..min..":"..(szro)..sec..":"..(tzro)..tik..""




	end

end





function Triggers.player_revived(P)
	if (Game.type ~= "netscript") then
		Players.print("The rule NETSCRIPT must be chosen so you can play the rule.")
		P:damage(500, teleporter)
	end
end



